﻿; /// constants to manage PB keywords listed in LineActionFlag

; reserved up to                     
#DONT_SKIP_THIS_LINE                 = 0
#SKIP_THIS_LINE                      = 1
#START_BLOCK_SKIPPING_FROM_THIS_LINE = 2
#STOP_BLOCK_SKIPPING_FROM_NEXT_LINE  = 3
#STOP_BLOCK_SKIPPING_FROM_THIS_LINE  = 4
#SKIP_2_LINES                        = 5 
#START_SKIP_ALL_DIRECTIVE            = 6 
#STOP_SKIP_ALL_DIRECTIVE             = 7 
#START_PB_SETTINGS                   = 8  
#SKIP_LPP_DIRECTIVE                  = 9  
#START_LOOP_SKIPPING_FROM_THIS_LINE  = #START_BLOCK_SKIPPING_FROM_THIS_LINE
#STOP_LOOP_SKIPPING_FROM_NEXT_LINE   =  #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE

#SKIP_LOOPS_DIRECTIVE                = 10 
#TRACE_LOOPS_DIRECTIVE               = 11  

#TRACE_THIS_LINE                     = 12   ; override every other flag
; reserved up to                     
#MAX_LINE_ACTION_FLAG                = 10000 ; 2^16

; 
#ADD_CMD_HRTIMER_START               = #MAX_LINE_ACTION_FLAG +1
#ADD_CMD_HRTIMER_STOP                = #MAX_LINE_ACTION_FLAG +2

#MaxKwsID = 50
Global LoopsK1, LoopsK2
Global Dim skw.s(#MaxKwsID): 
Global Dim LineActionFlag.l(#MaxKwsID): 
Global Dim ValidCharsAfter.s(#MaxKwsID) ; Global Dim ValidCharsBefore.s(#MaxKwsID): 
Global Dim DbgStrAfter.b(#MaxKwsID)     ; std is before (0), exception is after (1)
Global sValidCharsBefore.s = " :"+#TAB$, InclFNId, ProcRetId, ProcIdx
Declare.l IncL(*lng)
Define MaxKW, k, LOOPSKIPDIR.l = 1

; Special PureBasic KeyWords
k=0                               : LineActionFlag(k) = #DONT_SKIP_THIS_LINE
skw(IncL(@k)) = "IncludeFile"     : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ("+Chr(34)+#TAB$
InclFNId = k
skw(IncL(@k)) = "XIncludeFile"    : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ("+Chr(34)+#TAB$
skw(IncL(@k)) = "IncludePath"     : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ("+Chr(34)+#TAB$
skw(IncL(@k)) = "EnableExplicit"  : LineActionFlag(k) = #SKIP_THIS_LINE                         : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "EndStructure"    : LineActionFlag(k) = #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "Structure"       : LineActionFlag(k) = #START_BLOCK_SKIPPING_FROM_THIS_LINE    : ValidCharsAfter(k) = " "+#TAB$
LoopsK1 = k+1
skw(IncL(@k)) = "For"             : LineActionFlag(k) = #START_LOOP_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Next"            : LineActionFlag(k) =  #STOP_LOOP_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "While"           : LineActionFlag(k) = #START_LOOP_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Wend"            : LineActionFlag(k) =  #STOP_LOOP_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "Repeat"          : LineActionFlag(k) = #START_LOOP_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "Until"           : LineActionFlag(k) =  #STOP_LOOP_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :"+#TAB$
LoopsK2 = k
skw(IncL(@k)) = "With"            : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Global"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Define"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Shared"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Protected"       : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "DeclareCDLL"     : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "DeclareDLL"      : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Declare"         : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "ProcedureReturn" : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " (;"+#TAB$
ProcRetId = k
skw(IncL(@k)) = "ProcedureCDLL"   : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "ProcedureDLL"    : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "EndProcedure"    : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " :;"+#TAB$
skw(IncL(@k)) = "ProcedureC"      : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$
skw(IncL(@k)) = "Procedure"       : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " ."+#TAB$   : DbgStrAfter(k)=1
ProcIdx = k
; skw(IncL(@k)) = "EndSelect"       : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Select"          : LineActionFlag(k) = #SKIP_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$
skw(IncL(@k)) = "Case"            : LineActionFlag(k) = #DONT_SKIP_THIS_LINE: ValidCharsAfter(k) = " "+#TAB$: DbgStrAfter(k)=1

skw(IncL(@k)) = "EndMacro"        : LineActionFlag(k) =  #STOP_BLOCK_SKIPPING_FROM_NEXT_LINE     : ValidCharsAfter(k) = " :"+#TAB$
skw(IncL(@k)) = "Macro"           : LineActionFlag(k) = #START_BLOCK_SKIPPING_FROM_THIS_LINE     : ValidCharsAfter(k) = " "+#TAB$

; Tracer program directives
skw(IncL(@k)) = "$DisableDebugOutput": LineActionFlag(k) = #START_SKIP_ALL_DIRECTIVE    ; without ; to avoid problems with commented lines
skw(IncL(@k)) = "$EnableDebugOutput" : LineActionFlag(k) =  #STOP_SKIP_ALL_DIRECTIVE    ; 
skw(IncL(@k)) = "IDE Options"     : LineActionFlag(k) = #START_PB_SETTINGS              ; set init of settings at the end of the pb file
skw(IncL(@k)) = "$DisTracer"      : LineActionFlag(k) = #START_SKIP_ALL_DIRECTIVE       ; 
skw(IncL(@k)) = "$EnTracer"       : LineActionFlag(k) = #START_SKIP_ALL_DIRECTIVE       ; 
skw(IncL(@k)) = "$DisDBG"         : LineActionFlag(k) = #START_SKIP_ALL_DIRECTIVE       ; 
skw(IncL(@k)) = "$EnDBG"          : LineActionFlag(k) =  #STOP_SKIP_ALL_DIRECTIVE       ;
skw(IncL(@k)) = "$Trace"          : LineActionFlag(k) = #TRACE_THIS_LINE               ;
skw(IncL(@k)) = "$DisLoops"       : LineActionFlag(k) = #SKIP_LOOPS_DIRECTIVE     ;     (Default)
skw(IncL(@k)) = "$EnLoops"        : LineActionFlag(k) = #TRACE_LOOPS_DIRECTIVE     ;

; Tracer program code commands
skw(IncL(@k)) = "$HRTStart"       : LineActionFlag(k) = #ADD_CMD_HRTIMER_START          ; 
skw(IncL(@k)) = "$HRTStop"        : LineActionFlag(k) = #ADD_CMD_HRTIMER_STOP           ; 

; Little PureBasic Preprocessor Directive
skw(IncL(@k)) = "$LPP"            : LineActionFlag(k) = #SKIP_LPP_DIRECTIVE; | #SKIP_THIS_LINE                 
skw(IncL(@k)) = " _"              : LineActionFlag(k) = #SKIP_2_LINES                   ; LPP line breaker

MaxKW = k

; uncomment
;+ ====> Procedure DebugF(st.s, AppendF.b=1, SkipF.b=0, DisableF.l=-999)
; CompilerIf Defined(lDebugF, #PB_Procedure) = 0
; Procedure lDebugF(st.s, AppendF.b=1)
; Protected fn.s ="c:\debugf.dbg", f.l, ret, lastErr
; 
;     CompilerIf Defined(DebugFN$, #PB_Constant)
;         fn = #DebugFN$
;     CompilerEndIf
;     
;     If AppendF
;         ; Debug GetLastError_() = 0
;         lastErr = GetLastError_()
;         f = OpenFile(#PB_Any, fn)
;         ; Debug GetLastError_() = 183 if file exist
;         SetLastError_(LastErr)
;         FileSeek(f, FileSize(fn))
;         
;     Else
;         f = CreateFile(#PB_Any, fn)
;         If st = "" 
;             st = "Run: "+FormatDate("%dd/%mm/%yyyy - %hh:%ii:%ss", Date())  
;         EndIf
;     EndIf
;         
;     If f 
;         WriteStringN(f, st)
;         FlushFileBuffers(F)
;         CloseFile(f)
;         ProcedureReturn 1 ; routine processed
;         
;     Else
;         ProcedureReturn 0 ; routine NOT processed
; 
;     EndIf
;     
; EndProcedure
; CompilerEndIf
;-

Procedure.s AddSpaces(String$, MaxLenght)
Protected sRes.s, spc

    String$ = ReplaceString(String$, #TAB$, sTabLen)
    
    If MaxLenght = 0
        sRes = String$

    Else

        spc = MaxLenght - Len(String$) 
        If spc < 0                                          ; truncate
            sRes = String$

        Else                                                ; remove last 3 closing line chars ')" - add spaces and re-add 3 closing line chars
            sRes = String$+Space(spc)

        EndIf

    EndIf
    
ProcedureReturn sRes

EndProcedure

Procedure ShowHelp(param.s)
        
        PrintN("Command line: Tracer <filename> [parameters]")
        PrintN("")
        PrintN("/h or /? = show this help screen (/hd shows DIRECTIVES only)")
        PrintN("")
        If param <> "/hd"
            PrintN("<SourceFN>  = set the input filename (first parameter mandatory)")
            PrintN("/of<DestFN> = set the Output Filename")
            PrintN("                 if empty, the same name with prefix _$_ will be used")
            PrintN("                 if a directory, it is used for output")
            PrintN("/tg<Target> = set the destination of the debug output string. Values are: ")
            PrintN("              DebugView - use DebugView by Sysinternals as destination")
            PrintN("              StdFile   - write output to disk file c:\debugf.dbg")
            PrintN("              number    - process id (decimal or hex) of a running program to")
            PrintN("                          send the strings via PeekMessage - no error check")
            PrintN("              Class, Window - Class name and/or Window Title of the destination")
            PrintN("                              application PeekMessage the debug strings to")
            PrintN("/fl<Filter> = set the FLlter string to identify output (Default 'FileName.Ext')")
            PrintN("/def     = use DEFault settings, when not specified (overidden)")
                  ; +--------++--------++--------++--------++--------++--------++--------++--------+
            PrintN("/af#     = set the info to send to debug output     (es. /af1 - Default = 3)")
            PrintN("             bitflag of 1, 2 and 4  =>  0= Line Numbers (always)")
            PrintN("                                        1 = Procedure Names")
            PrintN("                                        2 = Procedure Address")
            PrintN("                                        4 = Line Address (TO BE IMPLEMENTED)")
            PrintN("")
            PrintN("/ln#     = space in char for the Line Number        (es. /ln8 - Default = 5)")
            PrintN("/pn#     = space in char for the Procedure Name     (es. /pn25 - Default = 20)")
            PrintN("/pa#     = space in char for the Procedure Address  (es. /pa10 - Default = 8)")
            PrintN("/xc#     = limit the debug output string to the given length in Characters")
            PrintN("           for dest. file readability; 0 = no limit (es. /xc100 - Default = 125)")
            PrintN("/ac(0-1) = Add the Code in the debug output string  (es. /ac0 - Default = 1)")
            PrintN("/he(0-1) = write numbers in HEx format              (Default = 1)")
            PrintN("/el(0-1) = add an Empty Line at the the beginning of the debug session")
            PrintN("             (Default = 1) ")
            PrintN("/sp(0-1) = add an empty line at the entry of every procedure (for readeability)")
            PrintN("             (Default = 1)")
            PrintN("/md(0-1) = if the lDebugF procedure is Missing (and needed), add a reference ")
            PrintN("             to a file that must be in the source directory (Default = 0)")
            PrintN("/hr(0-1) = if the HRTimer is missing (and needed), add a reference to a file ")
            PrintN("             to a file that must be in the source directory     (Default = 1)")
            PrintN("/cd(0-1) = try to Clear DebugView log list                      (Default = 1)")
            PrintN("/rn(0-1) = RuN the purebasic editor after finishing             (Default = 0)")
            PrintN("/tc(0-1) = Test generated Code with pbcompiler                  (Default = 0)")
            PrintN("/on(0-1) = execute Only if source file is Newer than dest file  (Default = 0)")
            PrintN("/sl(0-1) = run without prompting messages (SiLent)              (Default = 0)")
            PrintN("/if(0-1) = ricursively trace also files in the IncludeFile/Path (Default = 0)")
            PrintN("/ri(0-1) = add a Run Info comment in the first line             (Default = 1)")
            PrintN("/sd(0-1) = All files generated are Saved in the dest. folder    (Default = 1)")
            PrintN("/sv(0-1) = enable the Variable view feature (TO BE IMPLEMENTED) (Default = 1)")
            PrintN("")
            PrintN("tip: adding some empty lines at the begin of your source code file allow Tracer")
            PrintN("       to use them for IncludeFile and TimeStamp line preserving line number")
            PrintN("       corrispondence between source and destination file")
            PrintN("")
        EndIf

                   ;|--------++--------++--------++--------++--------++--------++--------++--------!
        PrintN("DIRECTIVES:")
        PrintN("Source Code DIRECTIVES: added to the source code to take special actions")
        PrintN("                        includes ';' to have it ignored by PB")
        ; Tracer program directives
        PrintN(";$DisableDebugOutput= disable adding the debug output code until")
        PrintN("                      ;$EnableDebugOutput (or ;$EnDBG or ;$EnTfracer) is found")
        PrintN(";$DisDBG, $DisTracer= same as above (short format) ")
        PrintN(";$EnableDebugOutput = enable adding the debug output code (Default)")
        PrintN(";$EnDBG, $EnTracer  = same as above (short format) ")
        PrintN(";$DisLoops          = Skip Loops (For/Next, While/Wend, Repeat/Until) (Default)")
        PrintN(";$DisLoops              to avoid eccessive and useless use of ouput string")
        PrintN(";$EnLoops           = Enable loops (For/Next, While/Wend, Repeat/Until) ")
        PrintN(";$EnLoops               Enable Trcaer in the Loops (when iterations are not many")
        PrintN(";$Trace             = force tracing of current line (override everything)")
        PrintN(";IDE Options        = indicate the beginning of the PB IDE options section")
        PrintN("                      to be skipped")

        ; Tracer program code commands
        PrintN("")
        PrintN("Source code COMMANDS: instruct Tracer to add commands in the dest. file")
        PrintN("Code PROFILING commands"); without ;
        PrintN(";$HRTStart           = add a High Resolution Timer Start command"); without ;
        PrintN(";$HRTStop            = add a High Resolution Timer Stop command and show result")
        
        PrintN("")
        PrintN("Other DIRECTIVES:")
        ; Little PureBasic Preprocessor Directive
        PrintN(";$LPP                = Little PureBasic Preprocessor (LPP) Directive")
        PrintN("' _' characters      = Little PureBasic Preprocessor Line Breaker"); LPP line breaker
    
EndProcedure

Procedure.s StringFieldKey(String$, Key$, sDefault$="", Sep.s="/")
Protected ini, fin, CmdLn.s, sRes.s

    If Sep = "": Sep = Left(Key$, 1): EndIf
    ; CmdLn = LCase(String$ + Sep)
    ini = FindString(LCase(String$)+Sep, Key$, 1)
    
    If ini 
        ini = ini +Len(Key$)
        CmdLn = LTrim(Mid(String$, ini))+Sep
        fin = FindString(CmdLn, Sep, 1)
        
        If fin
            sRes = Trim(Left(CmdLn, fin-1))
            ProcedureReturn sRes
            
        EndIf
    
    Else
    
        ProcedureReturn sDefault$
    
    EndIf
    
EndProcedure

Procedure.s GetCmdLineParam(sCmdLn.s, sFlag.s, sDef.s="")
Protected ini, fin, CmdLn.s, sRes.s

    cmdln = LCase(sCmdLn + " ")
    ini = FindString(CmdLn, sFlag, 1)
    
    If ini 
        ini = ini +Len(sFlag)
        CmdLn = LTrim(Mid(cmdln, ini))
        fin = FindString(CmdLn, " ", 1)
        
        If fin
            sRes = Trim(Left(CmdLn, fin))
            ProcedureReturn sRes
        EndIf
    
    EndIf
    
    ProcedureReturn sDef
    
EndProcedure

Procedure.s ReplC(sProcAddr.s)

    ProcedureReturn ReplaceString(sProcAddr, "'", ""+Chr(34)+"")
    
EndProcedure

Procedure.l IncL(*lng)
Protected lng.l

    lng = PeekL(*lng)
    lng = lng + 1
    PokeL(*lng, lng)
    
    ProcedureReturn lng
    
EndProcedure

Procedure HasCharBeforeAndAfter(String$, Index)
Protected car.s, pos

   If ValidCharsAfter(Index) = ""                               ; if not defined it is a directive
        ProcedureReturn 0
        
    EndIf
    car = ""
    pos = FindString(LCase(String$), LCase(skw(Index)), 1)        ; get keyword position
    If pos > 1
        car = LCase(Mid(String$, pos-1, 1))                       ; check if it is Whole Word
    EndIf
    
;     Debug String$
;     Debug car
    If car <> "" And Not FindString(sValidCharsBefore, car, 1)  ; a character before the KeyWord if found (es QueryPer'for'manceFrequency)
        ; CallDebugger
        ProcedureReturn 1
        
    EndIf
    
    car = Mid(String$, pos+Len(skw(Index)), 1)
;     Debug car
    If car <> "" And Not FindString(ValidCharsAfter(Index), car, 1)
        ; CallDebugger
        ProcedureReturn 1
    EndIf

    ProcedureReturn 0                                       ; no chars before or after: it is a pure keyword

EndProcedure

Procedure.s GetKeyWord(sLine.s, kw.s, kwIdx, FlagF.b=0)
Protected pos, pos2, ini, fin, ProcName.s

    sLine = LTrim(sLine)                                 ; remove comment (for safety)
    pos = FindString(sLine, ";", 1)
    pos2 = FindString(sLine, ";$", 1) + FindString(sLine, "; IDE Options", 1)
    If pos And Not pos2
        sLine = Mid(sLine, 1, pos)
    EndIf

    ; Debug kw
    pos = FindString(LCase(sLine), LCase(kw), 1)        ; look for Procedure name (to have procedure address)

    If Not pos
        ProcedureReturn ""
    EndIf
    
    If HasCharBeforeAndAfter(sLine, kwIdx)
        ProcedureReturn ""
    EndIf
    
    If FlagF = 0                                    ; if 0 (default) returns the word from the line    

        ini = FindString(LCase(sLine), " ", 1)
        If Not ini 
            ProcedureReturn ""
        EndIf
        fin = FindString(LCase(sLine), "(", ini)
        
        If fin
            ProcName = Trim(Mid(sLine, ini, fin - ini))
        EndIf
    Else
        
        ProcedureReturn kw                          ; if 1 (default) returns the word taken from the array of kws
    
    EndIf
        
    ProcedureReturn ProcName
    
EndProcedure

Procedure CheckSkipKeyWord(sLine.s)
Protected k, pos, st.s, car.s
    
    For k = 1 To ArraySize(LineActionFlag())
        If skw(k) = ""
            Break
        EndIf
        ; Debug skw(k)
        st = GetKeyWord(sLine, skw(k), k, 1)                ; here checks also character before and after
                                                            ; to be sure the whole word matches.
        If skw(k) <> "" And  st <> ""
        
            ProcedureReturn k

        EndIf
        
    Next k
    
    ProcedureReturn 0
    

EndProcedure

Procedure.s GetTCMItemText(hSysTab32, idx)
Protected Tabcnt, wLn, k, tagTC1.TC_ITEM, st.s

    st = Space(#MAX_PATH)
    
    tagTC1\cchTextMax = #MAX_PATH   
    
    tagTC1\mask = #TCIF_TEXT ; + #TCIF_PARAM 
    
    tagTC1\pszText = @st
    
    k = SendMessage_(hSysTab32, #TCM_GETITEM, Idx, @tagTC1)
    
    st = PeekS(tagTC1\pszText)
    
    ProcedureReturn st

EndProcedure

Procedure SelectTCMItem(hwnd, TCMToSelect.s)
Protected Tabcnt, k, Id, TCMText.s, newF, pbWnd, hSysTab32, cnt

    pbWnd = GetActiveWindow_()
    pbWnd = GetForegroundWindow_()
    
    hSysTab32 = GetDlgItem_(pbWnd, 1)
    
    cnt = SendMessage_(hSysTab32, #TCM_GETITEMCOUNT, 0, 0)

    For k = 0 To cnt

        TCMText = GetTCMItemText(hSysTab32, k-1)
        If TCMText = TCMToSelect

            Id = SendMessage_(hSysTab32, #TCM_SETCURSEL, 0, 0)       ; zero based
        
        EndIf
               
    Next k
    
    ;MessageRequester("k="+Str(k), ", hSysTab32="+Hex(hSysTab32))
    ProcedureReturn Id
    
EndProcedure

Procedure SendKey(Option.l)
      ; Author : Oliv
      ;If Option & #VK_SHIFT
        
      keybd_event_(Option, 0, 0, 0) ; Simulate Keypress
      keybd_event_(Option, 0, #KEYEVENTF_KEYUP, 0) ; Simulate release key
      Delay(60)
EndProcedure

Procedure SendKey_(VK_Key, Sh1Ctr2Alt4, msDel.l=0)
Protected ExtKey

      ; Author : Oliv
    If Sh1Ctr2Alt4 = 1 Or (Sh1Ctr2Alt4 & #VK_SHIFT) ; or (Sh1Ctr2Alt4 & #VK_LSHIFT) or (Sh1Ctr2Alt4 & #VK_RSHIFT)
        ExtKey = #VK_SHIFT
        
    ElseIf (Sh1Ctr2Alt4 = 2) Or (Sh1Ctr2Alt4 & #VK_CONTROL) 
        ExtKey = #VK_CONTROL
        
    ElseIf Sh1Ctr2Alt4 = 4 Or (Sh1Ctr2Alt4 & #VK_MENU) 
        ExtKey = #VK_MENU
        
    EndIf

    keybd_event_(ExtKey, 0, 0, 0)
    
        keybd_event_(VK_Key, 0, 0, 0)                   ; Simulate Keypress
        keybd_event_(VK_Key, 0, #KEYEVENTF_KEYUP, 0)    ; Simulate release key

    keybd_event_(ExtKey, 0, #KEYEVENTF_KEYUP, 0)
    

  Delay(msDel)
EndProcedure

Procedure SendKey_Msg(Option.l, Sh1Ctr2Alt4.l, msDel.l=0)
Protected ExtKey

      ; Author : Oliv
    If Sh1Ctr2Alt4 = 1 Or (Sh1Ctr2Alt4 & #VK_SHIFT) ; or (Sh1Ctr2Alt4 & #VK_LSHIFT) or (Sh1Ctr2Alt4 & #VK_RSHIFT)
        ExtKey = #VK_SHIFT
        
    ElseIf (Sh1Ctr2Alt4 = 2) Or (Sh1Ctr2Alt4 & #VK_CONTROL) 
        ExtKey = #VK_CONTROL
        
    ElseIf Sh1Ctr2Alt4 = 4 Or (Sh1Ctr2Alt4 & #VK_MENU) 
        ExtKey = #VK_MENU
        
    EndIf

    keybd_event_(ExtKey, 0, 0, 0)
    
        keybd_event_(Option, 0, 0, 0) ; Simulate Keypress
        keybd_event_(Option, 0, #KEYEVENTF_KEYUP, 0) ; Simulate release key

    keybd_event_(ExtKey, 0, #KEYEVENTF_KEYUP, 0)
    

  Delay(msDel)
EndProcedure

#EXE = 1
#DLL = 2
#IFNEWER = 4
#SILENT = 8
#EXECUTE = 16


Procedure Recompile(sInpF.s, sOutDir.s, *sRes, Flags = #EXE | #DLL | #IFNEWER | #SILENT | #EXECUTE)
Protected InpF.s, comp.s, params.s, pbPID, Output$, ExitCode2
Protected FileN.s, Ext.s, InpFTime, OutFTime, MsgIcon

    comp.s = Chr(34)+#PB_Compiler_Home+"compilers\pbcompiler.exe"+Chr(34)

    If sOutDir = ""
        sOutDir = #PB_Compiler_FilePath
    EndIf
    
    InpF.s = Chr(34)+sInpF+Chr(34)
    FileN = GetFilePart(InpF)
    Ext = GetExtensionPart(InpF)
    
    params =  InpF 
    If Flags & #EXE
        FileN = ReplaceString(FileN, Ext, "exe")
        params.s =  params + " /EXE "+Chr(34)+sOutDir+FileN+Chr(34)
    ElseIf Flags & #DLL
        FileN = ReplaceString(FileN, Ext, "dll")
        params.s =  params + " /EXE "+Chr(34)+sOutDir+FileN+Chr(34) +" /DLL"
    EndIf
    
    InpFTime = GetFileDate(sInpF, #PB_Date_Modified)
    OutFTime = GetFileDate(sOutDir+FileN, #PB_Date_Modified)
    
    If InpFTime > OutFTime Or (Not (Flags & #IFNEWER))
    
    ; +" > c:\pbc.txt"
        pbPID = RunProgram(comp, params, sOutDir, #PB_Program_Open | #PB_Program_Read); | #PB_Program_Write )

        If pbPID
            Output$ = "Program: "+comp+ Chr(13)
            Output$ = Output$ + "Params: "+#TAB$+StringField(params+"/", 1, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 2, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 3, "/") + Chr(13)
            Output$ = Output$ + "        "+#TAB$+StringField(params+"/", 4, "/") + Chr(13)

            While ProgramRunning(pbPID)
                Output$ = Output$ + ReadProgramString(pbPID) + Chr(13)
            Wend
            Output$ + #CRLF$; Chr(13) + Chr(13)
            ExitCode2 = ProgramExitCode(pbPID)
            
            If ExitCode2
                Output$ + "Exitcode: " + Str(ExitCode2) + " - COMPILER ERROR"
            Else
                Output$ + "Exitcode: " + Str(ExitCode2) + " - RESULT OK"
            EndIf
            
            If *sRes > 0
                PokeS(*sRes, Output$)
            EndIf
; VbCritical 16 Visualizza l'icona di messaggio critico.  
; VbQuestion 32 Visualizza l'icona di richiesta di avviso. 
; VbExclamation 48 Visualizza l'icona di messaggio di avviso. 
; VbInformation 64 Visualizza l'icona di messaggio di informazione. 
            
            
            
            If ExitCode2 <> 0
                If Not (Flags & #SILENT) : MessageRequester("Recompile /// WARNING: COMPILER ERROR ///", Output$, 16): EndIf
            Else
                If Not(Flags & #SILENT) : MessageRequester("Recompile : /// COMPILE OK ///", Output$, 0): EndIf
            EndIf
            
            If ExitCode2 = 0 
                If  Flags & #EXECUTE
                    pbPID = RunProgram(Chr(34)+sOutDir+FileN+Chr(34), "", sOutDir)
                
                Else
                    pbPID = 1
                EndIf
                
            Else
                pbPID = 0
                
            EndIf
        
            ProcedureReturn pbPID
        Else
        
            MessageRequester("ERROR", "ERROR")
            ProcedureReturn 0
        
        EndIf
    Else
    
        ProcedureReturn 1

    EndIf    

EndProcedure

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 211
; FirstLine = 168
; Folding = 0--
; EnableXP
; UseMainFile = Tracer.pb